///Feladat:
///Egy replgp adott tvolsgonknt megmrte a fkdfelszn magassgt.
///Keressk meg a legmagasabb horpadst (horpadsrl beszlnk, ha a felszn egy adott pontja
///kisebb mindkt szomszdjnl).
///Megold algoritmus: feltteles maximum keress
///Bemeneti adatok egy szveges fjlban vannak.
///Ksztsnk ktfle beolvas fggvnyt:
///(1) Elsknt az adatok darabszma tallhat a fjlban, majd utna felszn adatai.
///(2) Nincs megadva az adatok darabszma, fjl vgig kell olvasni.
///Kivtel dobssal jelezzk a kvetkez hibkat:
///-hibs fjlnv
///-1-es md esetn nincs elg adat a fjlban
///-hibs (nem szm) adat van a fjlban
#include <iostream>
#include <fstream>
#include <vector>
#include <stdlib.h>

using namespace std;

class Felszin
{
private:
    vector<int> _t;
    void feltolt1(ifstream&); ///darabszm szerint olvas
    void feltolt2(ifstream&); ///fjl vgig olvas

public:
    enum Hiba{HibasFajlnev,HibasAdat};
    Felszin(const string& fnev);
    bool legmagasabbHorpadas(int& max, int& ind); ///feltteles maximum keress
    void tesztkiiras();
};

int main()
{
    cout << "Adja meg a felszin adatait tartalmazo fajl nevet:" << endl;
    string fnev;
    cin>>fnev;
    int max,ind;
    try{
        Felszin f(fnev);
        f.tesztkiiras();
        bool l=f.legmagasabbHorpadas(max,ind);
        if(l){
            cout<<"Legmagasabb horpadas helye:"<<ind+1<<" erteke:"<<max<<endl;
        }else{
            cout<<"Nincs horpadas\n";
        }
    }catch(Felszin::Hiba err)
    {
        if(err==Felszin::HibasFajlnev)
        {
            cerr<<"A megadott fajl nem nyithato meg.\n";
            exit(1);
        }
        else if(err==Felszin::HibasAdat)
        {
            cerr<<"Tul keves, vagy hibas adat van a fajlban!\n";
            exit(2);
        }
    }
    return 0;
}


void Felszin::tesztkiiras()
{
    //teszt kiiras
    cout<<"Beolvasott adatok:\n";
    cout<<"n="<<_t.size()<<endl;
    for (int e:_t){cout<<e<<" ";}
    cout<<endl;
}
